import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

import java.util.List;
import java.util.ArrayList;

/**
 * Token. La ficha se mueve a la derecha (negra) o a la izquierda (roja)
 * 
 * @author Patricio Poblete
 * @version 1.0
 */
public class Token extends Actor
{
    private int direction;

    public Token(int d)
    {
        direction = d;
        if(direction==1)
            setImage("black.png");
        else
            setImage("red.png");
    }

    /**
     * Do whatever the wombat likes to to just now.
     */
    public void act()
    {
        if(Greenfoot.mouseClicked(this))
        {
            if(canMove())
                move();
            else if(canJump())
                jump();
        }
    }

   /**
     * Test if can move one cell forward in the current direction.
     */
    public boolean canMove()
    {
        return getOneObjectAtOffset(direction,0,null)==null;
    }
    /**
     * Move one cell forward in the current direction.
     */
    public void move()
    {
        setLocation(getX()+direction,0);
    }
   /**
     * Test if can jump two cells forward in the current direction.
     */
    public boolean canJump()
    {
        Token neighbor=(Token)getOneObjectAtOffset(direction,0,null);
        
        return neighbor!=null
            && neighbor.direction!=direction
            && getOneObjectAtOffset(2*direction,0,null)==null;
    }
    /**
     * Jump two cells forward in the current direction.
     */
    public void jump()
    {
        setLocation(getX()+2*direction,0);
    }
}
